<!--
////////////////////////////////////////////////////////////////////
//  Module Name : wiley document(JSP POSTDOCUMENT)                //
//  Page Name   : getDocument.jsp                                 //
//  ver 0.9						          //
//  Platform:      ...                                            //
//  Application:   Community Grids Labs, Wiley Document Project   //
//  Author:        Ali Kaplan,  alikapla@cs.indiana.edu           //
//                 Ahmet Topcu  atopcu@cs.indiana.edu             //
//                 Community Grids Labs, Indiana University       //
////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
    This jsp page gets the  document object from postDocument.jsp page
    having "documents" session object property.XML object and RSS objects
    are generated in this page, then insert xml and rss wiley objects into
    the database.

   java.io.StringWriter sw = new java.io.StringWriter();
   wiley.marshal(sw);                     //marshal the wiley object

   java.io.StringWriter swRSS = new java.io.StringWriter();
  //new string write object for rss
   item.marshal(swRSS);                  //marshal the rss
  //add data into database
  Database db =new Database();
  db.insertXMLContent("wileytest",documents.getArticleIdentification(),
                      swRSS.toString(), sw.toString());


/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
//                      maintenance page                           //
/////////////////////////////////////////////////////////////////////
//  Build Process                                                  //
//                                                                 //
// Files Required:                                                 //
// 1)postDocument.jsp,                                             //
// 2)commgrids.nuggets.wiley.bean.newdocParam.java                 //
// 3)all the java files under "commgrids.nuggets.wiley.schema"     //
// 4)all the java files under "commgrids.nuggets.wiley.rss.schema" //
/////////////////////////////////////////////////////////////////////
/*

    Maintenance History
    ===================
      ver 0.9 : Oct 26 2003
        - first release
      ver 0.91: Nov 21 2003 added multiple author and multiple keyword parts
      ver 0.92: Nov 23 2003 added userBean to get topic for posted message

    Planned Modifications:
    ======================

-->

<%@ page import="java.io.*,java.util.*,java.lang.String,java.util.Properties,
                 commgrids.nuggets.wiley.*,commgrids.nuggets.wiley.schema.*,
                 commgrids.nuggets.wiley.rss.schema.*"
         contentType="text/xml"
%>
<jsp:useBean id="userBean" scope="session" class="commgrids.nuggets.wiley.User"/>
<jsp:useBean id="documents" scope="page" class="commgrids.nuggets.wiley.bean.newdocParam" />
<jsp:setProperty name="documents" property="*" />


<%
 //get the number of author and number of keywords
 String numAuthor =request.getParameter("numOfAuthor");
 String numKeyword =request.getParameter("numOfKeyword");


///////////////wiley documents marshaling sections////////////////////////////////////

Wiley wiley =new Wiley();
////////// set the publisher Information /////////////////////////////////////
PublisherInfo  publisherInfo= new PublisherInfo();
publisherInfo.setPublisherName(documents.getPublisherName()); // set publisher name
publisherInfo.setPublisherLoc(documents.getPublisherLoc());   // set publisher location

wiley.setPublisherInfo(publisherInfo);                        // set publisher info to wiley
//////////////////////////////////////////////////////////////////////////////

///////////////set the journal Information ///////////////////////////////////
JournalInfo  journalInfo= new JournalInfo();
//set the id part//
journalInfo.setJID(documents.getJournalID()); // set the journal ID
//end set the id part//

//set the title parts//
JTitle jtitle =new JTitle();
jtitle.setLanguage(documents.getJournalTitleLang());  //set the journal title language
jtitle.setContent(documents.getJournalTitle());       //set the journal title content

journalInfo.setJTitle(jtitle);   // set the Journal Title
///end the title parts//

//set the journal title sort group
JTLSortGroup jtlSortGroup = new JTLSortGroup();
jtlSortGroup.setJTLDisplay(documents.getJournalSortDisplayer());
jtlSortGroup.setJTLSort(documents.getJournalSortGroup());

journalInfo.setJTLSortGroup(jtlSortGroup);
//end set the journal title sort group

//set the ISSN part
ISSN issn =new ISSN();
issn.setType(documents.getISSNType());
issn.setContent(documents.getISSN());

journalInfo.addISSN(0,issn);
//////////////////

// set the subject
journalInfo.setSubject(documents.getSubject());
//////////////////

wiley.setJournalInfo(journalInfo);                    //set the journal information to the wiley
//////////end setJournal Information section////////////////////////

/////////set the publication information////////////////
PublicationInfo publicationInfo =new PublicationInfo();
//set the issue ID//
publicationInfo.setIID(documents.getIID());

//set the Volume ID//
publicationInfo.setVID(documents.getVID());

//set the Cover Date/////////////////////
CoverDate coverDate =new CoverDate();

coverDate.setYear(documents.getYear());       // set the year
coverDate.setMonth(documents.getMonth());     // set the month
coverDate.setDay(documents.getDay());         // set the day

coverDate.setEndyear(documents.getEndYear());    // set the end year
coverDate.setEndmonth(documents.getEndMonth());  // set the end month
coverDate.setEndday(documents.getEndDay());      // set the end day

publicationInfo.setCoverDate(coverDate);
//end the set Cover Data////////////////////

wiley.setPublicationInfo(publicationInfo);      //set the publication info to the wiley
////////end the publication Information////////////////

///////set the article Contents///////////////////////////////
ArticleContent articleContent =new ArticleContent();

//set the article Information section/////////////////
ArticleInfo  articleInfo = new ArticleInfo();
articleInfo.setArticleIdentification(documents.getArticleIdentification());   //set the article Information
//set the digital object identifier section
DigitalObjectIdentifier dobjectId = new DigitalObjectIdentifier();
dobjectId.setHref(documents.getDOIURI());               //set the URI
dobjectId.setLevel(documents.getDOILevel());            //set the level
dobjectId.setOrigin(documents.getDOIOrigin());          //set the origin
dobjectId.setRegistered(documents.getDOIRegistered());  //set the register flag

articleInfo.setDigitalObjectIdentifier(dobjectId);
//end the digital object identifier section

//set the article type
ArticleType articleType =new ArticleType();
articleType.setArticleTy(documents.getArticleType());  //set the article type

articleInfo.setArticleType(articleType);
//end set article type

//set the category///
articleInfo.setCategory(documents.getCategory());
//end set category///

//set the article information//
articleContent.setArticleInfo(articleInfo);
//end the article information section////////////////////

//set the article title
articleContent.setArticleTitle(documents.getArticleTitle());
//end set article title

//set the author groups//////////////////////////////////////////////////////////////////////////////////////////
      AuthorGroup authorGroup = new AuthorGroup();

//////////////////////////added for multiple author below 11/21/03////////////////////////////////////////////
           int numAut=0;

           numAut=Integer.parseInt(numAuthor);
           String rssAuthorList="";
           if (numAut!=0)
              for (int i=0; i<numAut; i++)
              {
                 String authorFirstName =request.getParameter("author_fname_"+i);
                 String authorLastName =request.getParameter("author_lname_"+i);
                 String authorEmail =request.getParameter("author_email_"+i);
                 String affContent =request.getParameter("affiliation_content_"+i);
                 String affType =request.getParameter("affiliationType_"+i);
                 String affCountry =request.getParameter("affiliationCountry_"+i);


                 if (authorFirstName!=null && authorFirstName.length()>0){
                 Author author =new Author();

                 author.setFirstName(authorFirstName);   //set the first name
                 author.setLastName(authorLastName);     //set the last name
                 author.setEmailAddress(authorEmail);    //set the email address

                 if (rssAuthorList==null || rssAuthorList.equals(""))  //starting
                  rssAuthorList=rssAuthorList+authorFirstName+" "+authorLastName;
                    else
                  rssAuthorList=rssAuthorList+", "+authorFirstName+" "+authorLastName;  //adjust rss author object


                 Affiliation aff =new Affiliation();
                 aff.setCny(affCountry);              //set aff. country
                 aff.setContent(affContent);          //set aff. content
                 aff.setType(affType);                //set aff. type

                 author.setAffiliation(aff);       // set the aff

                 authorGroup.addAuthor(i,author);  //set the authorgroup
                 }//end for checking author name
              } //end for loop

      articleContent.setAuthorGroup(authorGroup); //set author group to the article content

//////////////////////////added for multiple author above////////////////////////////////////////////
////////////////////////end set the author group/////////////////////////////////////////////////////

//set the abstract section////
Abstract abstr = new Abstract();
abstr.setLanguage(documents.getAbsractLanguage());
abstr.setContent(documents.getAbstractParam());
articleContent.setAbstract(abstr);
//end the set abstract section///

//set the multiple keyword section///////////////////////////////////////////////////////////////////
           Keywords keywords =new Keywords();  //keyword object

           int numKey=0;
              String keyIntValue="";  //to convert string to integer
              numKey=Integer.parseInt(numKeyword);

             if (numKey!=0) {
                 for (int i=0; i<numKey; i++)
              {
              String keyValue =request.getParameter("keyword_"+i);
              if (keyValue!=null && keyValue.length()>0 ) {
                       keyIntValue=Integer.toString(i);
                       keywords.addKeyword(i, keyValue);
                    }
              } //end for loop

              } //end if statement
             articleContent.setKeywords(keywords);
 //////////////////////added for multiple keyword above///////////////////////////////////////////
////////////////////////end set keyword section///////////////////////////////////////////////////

wiley.setArticleContent(articleContent);   //set the article content to the wiley
//////end set article Contents/////////////////////////


//set the nugget id using DOI URI
wiley.setNuggetID(documents.getDOIURI());

//////////end wiley documents marshaling sections/////////////////////////////////////////////////

   java.io.StringWriter sw = new java.io.StringWriter();   // new string write object
   wiley.marshal(sw);                                      //marshal the wiley object

////////////////////////////////////rss section///////////////////////////////////////////////////
Item item =new Item();                                            //new RSS Item
item.setArticleTitle(documents.getArticleTitle());                //set the article title
item.setCategory(documents.getCategory());                        //set the category
item.setLink(documents.getDOIURI());                              //set the article URI
item.setArticleId(documents.getArticleIdentification());          //set the article identification
item.setAuthor(rssAuthorList ); //set the author
item.setDate(documents.getMonth()+ " "+documents.getDay()+ " "+documents.getYear()); //set the date
///////////////////////////////////end rss section////////////////////////////////////////////////


java.io.StringWriter swRSS = new java.io.StringWriter();           //new string write object for rss
item.marshal(swRSS);                                               //marshal the rss
//add data into database
Database db =new Database();
db.insertXMLContent(userBean.getTopic(),documents.getArticleIdentification(),swRSS.toString(), sw.toString());
%>
<%=sw.toString()%>
