package commgrids.nuggets.wiley.rss.settings;

import java.io.*;
import java.io.FileInputStream;

import java.net.*;

import java.util.*;

import javax.activation.*;

import commgrids.nuggets.wiley.Database;
import commgrids.nuggets.wiley.Util;

import org.apache.commons.httpclient.*;
import org.apache.commons.httpclient.methods.*;

import org.apache.soap.util.mime.*;


/**
 * DOCUMENT ME!
 *
 * @version $Revision: 1.1.1.1 $
 * @author $author$
 */
public class RSSConstructor {
    private static Database database          = null;
    private String          rssDescFileName   = null;
    private String          rssFooterFileName = null;
    private String          rssHeaderFileName = null;

    /**
     * Creates a new UrlContentReader object.
     */
    public RSSConstructor() {
        try {
            rssDescFileName   = Util.getProperties()
                                    .getProperty("rss.description.file.name");
            rssHeaderFileName = Util.getProperties()
                                    .getProperty("rss.header.file.name");
            rssFooterFileName = Util.getProperties()
                                    .getProperty("rss.footer.file.name");
            database          = new Database();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    /**
     * DOCUMENT ME!
     *
     * @param args DOCUMENT ME!
     */
    public static void main(String[] args) {
        RSSConstructor rc = new RSSConstructor();
       // System.out.println("RSS FILE\n" + rc.getRSS("/slide/testdir"));
    }

    /**
     * DOCUMENT ME!
     *
     * @param topic DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public synchronized String getRSS(String topic) {
        try {

            String rssMain = database.getMessagesRSSInfo(topic);

            if ((rssMain != null) && (rssMain.length() > 0)) {
                String output = getRSSHeader();
                output += rssMain;
                output += getRSSFooter();

                return output;
            } else {
                return null;
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        return null;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String getRSSFooter() {
        try {
            /*----------------BEGIN DEBUG------------------*
               InputStream    is = getClass()
                                       .getResourceAsStream("/"
                                                            + rssFooterFileName);
               BufferedReader in = new BufferedReader(new InputStreamReader(is));
               /*----------------END DEBUG--------------------*/
            BufferedReader in     = new BufferedReader(new FileReader(
                                                               rssFooterFileName));
            String         str;
            String         output = "";

            while ((str = in.readLine()) != null) {
                output += (str + "\n");
            }

            in.close();

            return output;
        } catch (IOException e) {
            e.printStackTrace();
        }

        return "";
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String getRSSHeader() {
        try {
            /*----------------BEGIN DEBUG------------------*
               InputStream    is = getClass()
                                       .getResourceAsStream("/"
                                                            + rssHeaderFileName);
               BufferedReader in = new BufferedReader(new InputStreamReader(is));
               /*----------------END DEBUG--------------------*/
            BufferedReader in     = new BufferedReader(new FileReader(
                                                               rssHeaderFileName));
            String         str;
            String         output = "";

            while ((str = in.readLine()) != null) {
                output += (str + "\n");
            }

            in.close();

            return output;
        } catch (IOException e) {
            e.printStackTrace();
        }

        return "";
    }
}