package commgrids.nuggets.wiley.sort;

import java.util.Vector;

abstract public class QuickSortGeneric {

    //private String sortType="";
    // Sorts entire array
    public void sort(Vector array)
    {
          //sortType = type;
          sort(array, 0, array.size()-1);
    }

    // Sorts partial array
    public void sort(Vector array, int start, int end)
    {
        int p;
        if (end > start)
        {
            p = partition(array, start, end);
            sort(array, start, p-1);
            sort(array, p+1, end);
        }
    }

    abstract protected int compare(Object a, Object b);

    protected int partition(Vector array, int start, int end)
    {
        int left, right;

        // Arbitrary partition start...there are better ways...
        Object partitionElement = array.elementAt(end);

        left = start - 1;
        right = end;
        for (;;)
        {
            while (compare(partitionElement, array.elementAt(++left)) == 1)
            {
                if (left == end) break;
            }
            while (compare(partitionElement, array.elementAt(--right)) == -1)
            {
                if (right == start) break;
            }
            if (left >= right) break;
            swap(array, left, right);
        }
        swap(array, left, end);

        return left;
    }

    protected void swap(Vector array, int i, int j)
    {
        Object temp;

        temp = array.elementAt(i);
        array.setElementAt(array.elementAt(j), i);
        array.setElementAt(temp, j);
    }

    public static void main(String[] args){
       /*
          Database database = new Database("adminmenu.properties");
          Vector vector = database.getTopicList();
          System.out.println("Vector size is "+vector.size());
       */


    }
}