package commgrids.nuggets.wiley;

import java.util.Vector;
import commgrids.nuggets.wiley.rss.settings.RSSElement;
import commgrids.nuggets.wiley.rss.settings.RSSParser;


/**
 * DOCUMENT ME!
 *
 * @version $Revision: 1.1.1.1 $
 * @author $author$
 */
public class MessageThread {

    private String nextLink  = "";
    private String prevLink  = "";
    private Vector msgVector = null;

    /**
     * Creates a new MessageThread object.
     */
    public MessageThread(Vector vector) {
        msgVector = vector;
    }

    /**
     * Creates a new MessageThread object.
     */
    public MessageThread() {
        msgVector = new Vector();
    }

    /**
     *
     * @param aMsgVector - the new value for msgVector
     */
    public void setMsgVector(Vector vector) {

        if (vector != null) {
            msgVector = new Vector();

            for (int i = 0; i < vector.size(); i++) {

                RSSElement re = (RSSElement) vector.get(i);
                msgVector.add(re.getArticleId().trim());
                //System.out.println("Output " + (String) msgVector.get(i));
            }
        }
    }

    /**
     *
     * @return the MyVector value of msgVector.
     */
    public Vector getMsgVector() {

        return msgVector;
    }

    /**
     *
     * @param aNextLink - the new value for nextLink
     */
    public void setNextLink(String aNextLink) {
        nextLink = aNextLink;
    }

    /**
     *
     * @return the String value of nextLink.
     */
    public String getNextLink() {

        return nextLink;
    }

    /**
     *
     * @param aPrevLink - the new value for prevLink
     */
    public void setPrevLink(String aPrevLink) {
        prevLink = aPrevLink;
    }

    /**
     *
     * @return the String value of prevLink.
     */
    public String getPrevLink() {

        return prevLink;
    }

    /**
     * DOCUMENT ME!
     *
     * @param uri DOCUMENT ME!
     */
    public void findPlace(String uri) {
       prevLink ="";
       nextLink="";

        int location = msgVector.indexOf(uri);
        /*
        System.out.println(uri + " Location " + location);
        location = msgVector.indexOf("/slide/testdir/myApp.doc");
        System.out.println("/slide/testdir/myApp.doc Location " + location);
        location = msgVector.indexOf("/slide/testdir/app.doc");
        System.out.println("/slide/testdir/app.doc Location " + location);
        */

        if (location >= 1) {
            prevLink = (String) msgVector.get(location - 1);
        }

        if (location <= (msgVector.size() - 2)) {
            nextLink = (String) msgVector.get(location + 1);
        }
    }

    /**
     * DOCUMENT ME!
     *
     * @param args DOCUMENT ME!
     */
    public static void main(String[] args) {

        try {

            MessageThread messageThread1 = new MessageThread();
            RSSParser     rp       = new RSSParser();
            Vector        vector   = rp.parseRSS("","/slide/testdir");
            String        prevLink = "";
            String        nextLink = "";

            if ((vector != null) && (vector.size() > 0)) {
                messageThread1.setMsgVector(vector);
                messageThread1.findPlace("/slide/testdir/test.html");
                /*
                System.out.println("prev link " +
                                   messageThread1.getPrevLink());
                System.out.println("next link " +
                                   messageThread1.getNextLink());
                */
            }
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
}