package commgrids.nuggets.wiley.rss.settings;

import java.io.StringReader;

import java.util.Hashtable;

import commgrids.nuggets.wiley.Database;

import commgrids.nuggets.wiley.userconfig.Col;
import commgrids.nuggets.wiley.userconfig.Userconfig;


/**
 * DOCUMENT ME!
 *
 * @version $Revision: 1.1.1.1 $
 * @author $author$
 */
public class RSSDisplayerPageSettings {

    private Hashtable lengthHashTable = null;
    private Hashtable orderHashTable  = null;
    private String    defaultSortType = null;
    private String    searchText      = null;
    private String    searchType      = null;
    private String    sortType        = null;
    private String    topic           = null;
    private Col[]     rssColumns      = null;
    private int       beginIndex      = 1;
    private int       chunkSize       = 7;
    private int       columnNumber    = 0;

    /**
     * Creates a new RSSDisplayerPageSettings object.
     */
    public RSSDisplayerPageSettings() {
    }

    /**
     *
     * @param aBeginIndex - the new value for beginIndex
     */
    public void setBeginIndex(int aBeginIndex) {
        beginIndex = aBeginIndex;
    }

    /**
     *
     * @return the int value of beginIndex.
     */
    public int getBeginIndex() {

        return beginIndex;
    }

    /**
     *
     * @param aChunkSize - the new value for chunkSize
     */
    public void setChunkSize(int aChunkSize) {
        chunkSize = aChunkSize;
    }

    /**
     *
     * @return the int value of chunkSize.
     */
    public int getChunkSize() {

        return chunkSize;
    }

    /**
     *
     * @param aColumnNumber - the new value for columnNumber
     */
    public void setColumnNumber(int aColumnNumber) {
        columnNumber = aColumnNumber;
    }

    /**
     *
     * @return the int value of columnNumber.
     */
    public int getColumnNumber() {

        return columnNumber;
    }

    /**
     *
     * @param aDefaultSortType - the new value for defaultSortType
     */
    public void setDefaultSortType(String aDefaultSortType) {
        defaultSortType = aDefaultSortType;
    }

    /**
     *
     * @return the String value of defaultSortType.
     */
    public String getDefaultSortType() {

        return defaultSortType;
    }

    /**
     *
     * @param aLengthHashTable - the new value for lengthHashTable
     */
    public void setLengthHashTable(Hashtable aLengthHashTable) {
        lengthHashTable = aLengthHashTable;
    }

    /**
     *
     * @return the Hashtable value of lengthHashTable.
     */
    public Hashtable getLengthHashTable() {

        return lengthHashTable;
    }

    /**
     *
     * @param aOrderHashTable - the new value for orderHashTable
     */
    public void setOrderHashTable(Hashtable aOrderHashTable) {
        orderHashTable = aOrderHashTable;
    }

    /**
     *
     * @return the Hashtable value of orderHashTable.
     */
    public Hashtable getOrderHashTable() {

        return orderHashTable;
    }

    /**
     *
     * @param aRssColumns - the new value for rssColumns
     */
    public void setRssColumns(Col[] aRssColumns) {
        rssColumns = aRssColumns;
    }

    /**
     *
     * @return the Col[] value of rssColumns.
     */
    public Col[] getRssColumns() {

        return rssColumns;
    }

    /**
     *
     * @param aSearchText - the new value for searchText
     */
    public void setSearchText(String aSearchText) {
        searchText = aSearchText;
    }

    /**
     *
     * @return the String value of searchText.
     */
    public String getSearchText() {

        return searchText;
    }

    /**
     *
     * @param aSearchType - the new value for searchType
     */
    public void setSearchType(String aSearchType) {
        searchType = aSearchType;
    }

    /**
     *
     * @return the String value of searchType.
     */
    public String getSearchType() {

        return searchType;
    }

    /**
     *
     * @param aSortType - the new value for sortType
     */
    public void setSortType(String aSortType) {
        sortType = aSortType;
    }

    /**
     *
     * @return the String value of sortType.
     */
    public String getSortType() {

        return sortType;
    }

    /**
     *
     * @param aTopic - the new value for topic
     */
    public void setTopic(String aTopic) {
        topic = aTopic;
    }

    /**
     *
     * @return the String value of topic.
     */
    public String getTopic() {

        return topic;
    }

    /**
     * DOCUMENT ME!
     */
    public void getUserConfig(String username,String topicname) {

        try {

            Userconfig uc = null;
            columnNumber    = 0;
            orderHashTable  = null;
            lengthHashTable = null;
            orderHashTable  = new Hashtable();
            lengthHashTable = new Hashtable();

            Database db     = new Database();

            /*
               FileReader fr = new FileReader(
                                                   "J:/MetadataBrowserClassic/xmlSchema/userconfig2.xml");
             */
            String config = db.getUserConfiguration(username,topicname);


           // System.out.println("\n" + config);
            //if(config != null && config.length() > 0 ){
            System.out.println(config);
            uc              = uc.unmarshal(new StringReader(config));
            defaultSortType = uc.getScreenview()
                                .getDefaultsort();

            for (int i = 0; i < uc.getScreennames()
                                  .getCol().length; i++) {

                if (uc.getScreennames()
                      .getCol(i)
                      .getOrder() >= 0) {
                    this.columnNumber++;
                }

                orderHashTable.put(uc.getScreennames().getCol(i).getName(),
                                   new Integer(uc.getScreennames().getCol(i).getOrder()));
                lengthHashTable.put(uc.getScreennames().getCol(i).getName(),
                                    new Integer(uc.getScreennames().getCol(i).getLength()));
            }

            rssColumns = new Col[this.columnNumber];

            for (int i = 0; i < uc.getScreennames()
                                  .getCol().length; i++) {

                if (uc.getScreennames()
                      .getCol(i)
                      .getOrder() >= 0) {
                    rssColumns[uc.getScreennames()
                                 .getCol(i)
                                 .getOrder()] = uc.getScreennames()
                                                  .getCol(i);
                }
            }

            //}
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    /**
     * DOCUMENT ME!
     */
    public void clear() {
        searchText = null;
        searchType = null;
        sortType   = null;
        chunkSize  = 10;
        beginIndex = 1;
    }

    /**
     * DOCUMENT ME!
     *
     * @param args DOCUMENT ME!
     */
    public static void main(String[] args) {

        RSSDisplayerPageSettings RSSDisplayerPageSettings1 = new RSSDisplayerPageSettings();
        RSSDisplayerPageSettings1.getUserConfig("mvarank","Grids");
        RSSDisplayerPageSettings1.printUserConfig();
    }

    /**
     * DOCUMENT ME!
     */
    public void printUserConfig() {
        System.out.println("RSS element number is " + this.columnNumber);

        for (int i = 0; i < this.columnNumber; i++) {
            System.out.println(rssColumns[i].getName() + "\t "
                               + rssColumns[i].getContent() + "\t"
                               + rssColumns[i].getLength());
        }
    }
}