package newsrequest;

/**
 * <p>Title: </p>
 * <p>Description: newsgroup request</p>
 * <p>Copyright: Copyright (c) 2001</p>
 * <p>Company: Pervasive Tech Labs </p>
 * @author Ahmet E Topcu
 * @version 0.90
 */
import java.io.*;

import java.sql.*;

import java.util.*;

import commgrids.nuggets.wiley.Util;


/**
 * DOCUMENT ME!
 *
 * @version $Revision: 1.2 $
 * @author $author$
 */
public class RequestDatabase {
    private Connection connection                = null;
    private Statement  statement                 = null;
    private String     OracleDriver              = "";
    private String     defaultUserConfigFileName = "";
    private String     name                      = "";
    private String     password                  = "";
    private String     url                       = "";
    private User       user                      = null;
    private Vector     vector                    = null;
    private boolean    debug                     = false;

    /**
     * Creates a new RequestPageDB object.
     */
    public RequestDatabase() {
        try {
            OracleDriver              = Util.getProperties()
                                            .getProperty("jdbc.driver");
            url                       = Util.getProperties()
                                            .getProperty("jdbc.url");
            name                      = Util.getProperties()
                                            .getProperty("jdbc.name");
            password                  = Util.getProperties()
                                            .getProperty("jdbc.password");
            defaultUserConfigFileName = Util.getProperties()
                                            .getProperty("default.userconfiguration.file.name");
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    /**
     *
     * @return the Vector value of unselectedTopic.
     */
    public Vector getUnselectedTopic(String username) {
        Vector    resultVector = null;
        Vector    tempVector = null;
        String    topic      = "";
        String    query      = null;
        ResultSet rset       = null;

        try {
            resultVector = new Vector();
            tempVector   = new Vector();
            query        = "SELECT topicid FROM topics ORDER BY topicid";

            if (debug) {
                System.out.println(this.getClass().getName()
                                   + ".getUnselectedTopic " + query);
            }

            rset = statement.executeQuery(query);

            while (rset.next()) {
                resultVector.add(rset.getString("topicid"));
            }

            query = "SELECT DISTINCT topic FROM " + "usernewsgroup WHERE "
                    + "username =\"" + username + "\" ORDER BY topic";
            rset  = statement.executeQuery(query);

            while (rset.next()) {
                tempVector.add(rset.getString("topic"));
            }

            if (debug) {
                System.out.println(this.getClass().getName()
                                   + ".getUnselectedTopic " + query);
            }

            query = "SELECT DISTINCT topic FROM " + "requests WHERE "
                    + "username =\"" + username + "\" ORDER BY topic";
            rset  = statement.executeQuery(query);

            while (rset.next()) {
                topic = rset.getString("topic");

                if (!tempVector.contains(topic)) {
                    tempVector.add(topic);
                }
            }

            for (int i = 0; i < tempVector.size(); i++) {
                topic = (String) tempVector.get(i);

                if (resultVector.contains(topic)) {
                    resultVector.remove(topic);
                }
            }
        } catch (Exception ex) {
            if (debug) {
                System.out.println(this.getClass().getName()
                                   + ".getUnselectedTopic ");
            }

            ex.printStackTrace();
            resultVector = null;
        }

        return resultVector;
    }

    /**
     * DOCUMENT ME!
     *
     * @param username DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public int getUserConfirmedAccessNumbers(String username) {
        String query    = null;
        int    rowcount = 0;

        try {
            query = "SELECT COUNT(*) AS rowcount FROM usernewsgroup WHERE "
                    + "username =\"" + username + "\"";

            if (debug) {
                System.out.println(this.getClass().getName()
                                   + ".getUserConfirmedAccessNumbers " + query);
            }

            ResultSet rset = statement.executeQuery(query);

            if (rset.next()) {
                rowcount = rset.getInt("rowcount");
            }

            rset.close();
        } catch (Exception ex) {
            if (debug) {
                System.out.println(this.getClass().getName()
                                   + ".getUserConfirmedAccessRightsByUser ");
            }

            ex.printStackTrace();
        }

        return rowcount;
    }

    /**
     * DOCUMENT ME!
     *
     * @param username DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public Vector getUserConfirmedAccessRightsByUser(String username) {
        Vector resultVector = null;
        String query = null;

        try {
            query = "SELECT * FROM usernewsgroup WHERE " + "username =\""
                    + username + "\"";

            if (debug) {
                System.out.println(this.getClass().getName()
                                   + ".getUserConfirmedAccessRightsByUser "
                                   + query);
            }

            resultVector = new Vector();

            ResultSet rset = statement.executeQuery(query);
            resultVector = constructUser(rset);
            rset.close();
        } catch (Exception ex) {
            if (debug) {
                System.out.println(this.getClass().getName()
                                   + ".getUserConfirmedAccessRightsByUser ");
            }

            ex.printStackTrace();
            resultVector = null;
        }

        return resultVector;
    }

    /**
     * DOCUMENT ME!
     *
     * @param username DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public int getUserRequestedAccessNumbers(String username) {
        String query    = null;
        int    rowcount = 0;

        try {
            query = "SELECT COUNT(*) AS rowcount FROM requests WHERE "
                    + "username =\"" + username + "\"";

            if (debug) {
                System.out.println(this.getClass().getName()
                                   + ".getUserConfirmedAccessNumbers " + query);
            }

            ResultSet rset = statement.executeQuery(query);

            if (rset.next()) {
                rowcount = rset.getInt("rowcount");
            }

            rset.close();
        } catch (Exception ex) {
            if (debug) {
                System.out.println(this.getClass().getName()
                                   + ".getUserConfirmedAccessRightsByUser ");
            }

            ex.printStackTrace();
        }

        return rowcount;
    }

    /**
     * DOCUMENT ME!
     *
     * @param username DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public Vector getUserRequestedAccessRightsByUser(String username) {
        Vector resultVector = null;
        String query = null;

        try {
            query = "SELECT * FROM requests WHERE " + "username =\"" + username
                    + "\"";

            if (debug) {
                System.out.println(this.getClass().getName()
                                   + ".getUserConfirmedAccessRightsByUser "
                                   + query);
            }

            resultVector = new Vector();

            ResultSet rset = statement.executeQuery(query);
            resultVector = constructUser(rset);
            rset.close();
        } catch (Exception ex) {
            if (debug) {
                System.out.println(this.getClass().getName()
                                   + ".getUserConfirmedAccessRightsByUser ");
            }

            ex.printStackTrace();
            resultVector = null;
        }

        return resultVector;
    }

    /**
     * DOCUMENT ME!
     */
    public void close() {
        try {
            this.statement.close();
            this.connection.close();
        } catch (Exception ex) {
            System.err.println("Unable to fullfill query");
            ex.printStackTrace();
        }
    }

    /**
     * DOCUMENT ME!
     */
    public void debugOFF() {
        debug = false;
    }

    /**
     * DOCUMENT ME!
     */
    public void debugON() {
        debug = true;
    }

    /**
     * DOCUMENT ME!
     *
     * @param vector DOCUMENT ME!
     */
    public void handleRequest(Vector vector) {
        try {
            System.out.println("Vector size is " + vector.size());

            for (int i = 0; i < vector.size(); i++) {
                User user = (User) vector.get(i);

                if (user.getSelected()) {
                    deleteUserRequestedAccessRights(statement, user);
                    addUserRequestedAccessRights(statement, user);
                }

                if (user.getDeleted()) {
                    deleteUserRequestedAccessRights(statement, user);
                }
            }
        } catch (Exception ex) {
            if (debug) {
                System.out.println(this.getClass().getName()
                                   + ".handleUserRequests ");
            }

            ex.printStackTrace();
        }
    }

    /**
     * DOCUMENT ME!
     *
     * @param args DOCUMENT ME!
     */
    public static void main(String[] args) {
        RequestDatabase requestPageDB1 = new RequestDatabase();
    }

    /**
     * DOCUMENT ME!
     */
    public void open() {
        try {
            Class.forName(OracleDriver);
            connection = DriverManager.getConnection(url, name, password);
            statement  = connection.createStatement();
        } catch (Exception ex) {
            ex.printStackTrace();
            connection = null;
        }
    } //end open

    /**
     * DOCUMENT ME!
     *
     * @param statement DOCUMENT ME!
     * @param user DOCUMENT ME!
     */
    private void addUserRequestedAccessRights(Statement statement,
                                              User      user) {
        String query = null;

        try {
            query = "INSERT INTO requests (username,topic,email,"
                    + "readaccess,writeaccess,admin,emailnotify,"
                    + "attachnotify,ccnotify) VALUES(\"" + user.getUsername()
                    + "\",\"" + user.getTopicName() + "\",\"" + user.getEmail()
                    + "\"," + user.getRead() + "," + user.getWrite() + ","
                    + user.getAdmin() + "," + user.getEmailNotify() + ","
                    + user.getAttachNotify() + "," + user.getCCNotify() + ")";

            if (debug) {
                System.out.println(this.getClass().getName()
                                   + ".addUserRequestedAccessRights " + query);
            }

            statement.executeUpdate(query);
        } catch (Exception ex) {
            if (debug) {
                System.out.println(this.getClass().getName()
                                   + ".addUserRequestedAccessRights");
            }

            ex.printStackTrace();
        }
    }

    /**
     * DOCUMENT ME!
     *
     * @param rset DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    private Vector constructUser(ResultSet rset) {
        Vector resultVector = new Vector();
        User   user = null;

        try {
            while (rset.next()) {
                user = new User();
                user.setUsername(rset.getString("username"));
                user.setTopicName(rset.getString("topic"));
                user.setEmail(rset.getString("email"));
                user.setRead(rset.getInt("readaccess"));
                user.setWrite(rset.getInt("writeaccess"));
                user.setAdmin(rset.getInt("admin"));
                user.setEmailNotify(rset.getInt("emailnotify"));
                user.setAttachNotify(rset.getInt("attachnotify"));
                user.setCCNotify(rset.getInt("ccnotify"));

                //add new user to result vector
                resultVector.add(user);
            }
        } catch (Exception ex) {
            if (debug) {
                System.out.println(this.getClass().getName()
                                   + ".constructUser ");
            }

            ex.printStackTrace();
            resultVector = null;
        }

        return resultVector;
    }

    /**
     * DOCUMENT ME!
     *
     * @param statement DOCUMENT ME!
     * @param user DOCUMENT ME!
     */
    private void deleteUserRequestedAccessRights(Statement statement,
                                                 User      user) {
        String query = null;

        try {
            query = "DELETE FROM requests WHERE username=\""
                    + user.getUsername() + "\" and topic=\""
                    + user.getTopicName() + "\"";

            if (debug) {
                System.out.println(this.getClass().getName()
                                   + ".deleteUserRequestedAccessRights "
                                   + query);
            }

            statement.executeUpdate(query);
        } catch (Exception ex) {
            if (debug) {
                System.out.println(this.getClass().getName()
                                   + ".deleteUserRequestedAccessRights");
            }

            ex.printStackTrace();
        }
    }
}