package willeyconverter.util;

import java.util.*;
import java.net.*;
import java.io.*;
import commgrids.nuggets.wiley.*;
import commgrids.nuggets.wiley.schema.*;
import commgrids.nuggets.wiley.MessageThread;
import willeyconverter.util.*;
import java.io.FileInputStream;
import java.io.FileOutputStream;

/**
 * <p>FullWileyHTMLDocument: </p>
 *
 * <p>Generating the HTML documents:: </p>
 *
 * <p>Copyright: Copyright (c) 2006</p>
 *
 * <p>Community Grid Labs Indiana University: </p>
 * @author Ahmet E Topcu
 * @version 1.0
 */
public class FullWileyHTMLDocument {
  public static String DEFAULT_PROPERTIES = "metadatabrowser.properties";
  private String      topicFolder               = "";
  private String      dirName               = "";
  private String      resultFolderName               = "";

  public FullWileyHTMLDocument() {
    try {

   //topicFolder =Util.getProperties().getProperty("wiley.topic.folder.name");
   resultFolderName =Util.getProperties().getProperty("wiley.result.folder.name");

    }
    catch (Exception ex) {
      ex.printStackTrace();
    }


  }

  /*receives the unique uri of the meta-data file*/


  public void generateFullDocument() {

    //FullWileyHTMLDocument ffulldoc = new FullWileyHTMLDocument();
    //String output =ffulldoc.generateWileyOutput("CPE547");

    String outputResult = "";
    boolean append = true;
    PrintStream out = null;
    try {
      out = new PrintStream(new FileOutputStream("full/wiley2006full.html"));
    }
    catch (FileNotFoundException ex) {
    }
    System.setOut(out);

    File dirFile = new File(resultFolderName);

    String  fileNames[] =null;


    fileNames= dirFile.list();
    //System.out.println("dirFile.getAbsolutePath():"+ dirFile.getAbsolutePath()  );

    for (int i=0; i<fileNames.length; i++ ) {
      ;
     // System.out.println("fileNames"+i+":"+fileNames[i]);
    }


    for (int i = 0; i < fileNames.length; i++) {

      File file = new File(dirFile.getAbsolutePath()+"/" + fileNames[i]);
      String fContent = "";
      LightWileyHTMLDocument fHTML = new LightWileyHTMLDocument();
      fContent = fHTML.readFile(file);

      String content =generateWileyOutput(fContent);
     // String content = fileHTML1.generateXML(uri);

      System.out.println(content);

    }
  }

  public String generateWileyOutput(String resultData) {  //resultData is xml object
    Database database = new Database();


    RecursiveParser recParser = new RecursiveParser();
    if (resultData != null && resultData.length() > 0) {
      recParser.parseStringXML(resultData);
    }
    Vector resultVector = recParser.getNodeVector();

    String hrefValue = "";
    Keywords keywords = new Keywords();

//added for getting href attribute///////////////////////////////////////////////////
//updated 11/21/03 to extract desired objects and display them

    Hashtable messageContent = new Hashtable(); //messageContent
    messageContent.clear();
    for (int i = 0; i < resultVector.size(); i++) {
      XMLNodeObject nodeObject = new XMLNodeObject();
      nodeObject = (XMLNodeObject) resultVector.get(i);

      //publisher Name
      if (nodeObject.getNodeName().equals("publisherName") &&
          nodeObject.getNodeValue() != null &&
          nodeObject.getNodeValue().trim().length() > 0) {
        messageContent.put("publisherName", nodeObject.getNodeValue());
      }

      //publisher Location
      if (nodeObject.getNodeName().equals("publisherLoc") &&
          nodeObject.getNodeValue() != null &&
          nodeObject.getNodeValue().trim().length() > 0) {
        messageContent.put("publisherLoc", nodeObject.getNodeValue());
      }

      //Volume ID
      if (nodeObject.getNodeName().equals("VID") && nodeObject.getNodeValue() != null &&
          nodeObject.getNodeValue().trim().length() > 0) {
        messageContent.put("VID", nodeObject.getNodeValue());
      }

      //Volume ID
      if (nodeObject.getNodeName().equals("IID") && nodeObject.getNodeValue() != null &&
          nodeObject.getNodeValue().trim().length() > 0) {
        messageContent.put("IID", nodeObject.getNodeValue());
      }

      //ISSN
      if (nodeObject.getNodeName().equals("ISSN") && nodeObject.getNodeValue() != null &&
          nodeObject.getNodeValue().trim().length() > 0) {
        messageContent.put("ISSN", nodeObject.getNodeValue());
      }

      //article Identification
      if (nodeObject.getNodeName().equals("articleIdentification") &&
          nodeObject.getNodeValue() != null &&
          nodeObject.getNodeValue().trim().length() > 0) {
        messageContent.put("articleIdentification", nodeObject.getNodeValue());
      }

      //article Identification
      if (nodeObject.getNodeName().equals("category") &&
          nodeObject.getNodeValue() != null &&
          nodeObject.getNodeValue().trim().length() > 0) {
        messageContent.put("category", nodeObject.getNodeValue());
      }

      //article Identification
      if (nodeObject.getNodeName().equals("articleTitle") &&
          nodeObject.getNodeValue() != null &&
          nodeObject.getNodeValue().trim().length() > 0) {
        messageContent.put("articleTitle", nodeObject.getNodeValue());
      }

      //article Identification
      if (nodeObject.getNodeName().equals("abstract") &&
          nodeObject.getNodeValue() != null &&
          nodeObject.getNodeValue().trim().length() > 0) {
        messageContent.put("abstract", nodeObject.getNodeValue());
      }

      //DOI (uri)
      if (nodeObject.getNodeName().equals("digitalObjectIdentifier")) {
        for (int j = 0; j < nodeObject.getAttrVector().size(); j++) {
          XMLAttributeObject attrObject = new XMLAttributeObject();
          attrObject = (XMLAttributeObject) nodeObject.getAttrVector().get(j);
          if (attrObject.getAttributeName().equals("href") &&
              attrObject.getAttributeValue() != null &&
              attrObject.getAttributeValue().trim().length() > 0) {
            messageContent.put("href", attrObject.getAttributeValue());
          }
        } //end for loop
      } //end if

      //Cover Date
      if (nodeObject.getNodeName().equals("coverDate")) {
        for (int j = 0; j < nodeObject.getAttrVector().size(); j++) {
          XMLAttributeObject attrObject = new XMLAttributeObject();
          attrObject = (XMLAttributeObject) nodeObject.getAttrVector().get(j);
          if (attrObject.getAttributeName().equals("year") &&
              attrObject.getAttributeValue() != null &&
              attrObject.getAttributeValue().trim().length() > 0) {
            messageContent.put("year", attrObject.getAttributeValue());
          }
          if (attrObject.getAttributeName().equals("month") &&
              attrObject.getAttributeValue() != null &&
              attrObject.getAttributeValue().trim().length() > 0) {
            messageContent.put("month", attrObject.getAttributeValue());
          }
          if (attrObject.getAttributeName().equals("day") &&
              attrObject.getAttributeValue() != null &&
              attrObject.getAttributeValue().trim().length() > 0) {
            messageContent.put("day", attrObject.getAttributeValue());
          }
        } //end for loop for attributes
      } //end if statement

      //keywords

      if (nodeObject.getNodeName().equals("keyword") && nodeObject.getNodeValue() != null &&
          nodeObject.getNodeValue().trim().length() > 0) {
        keywords.addKeyword(nodeObject.getNodeValue());
      }

      //add to the hash table
      //authors

    } //end for loop I assume
    if (keywords != null) {
      messageContent.put("keyword", keywords); //put keywords to the hash table
    }

    Wiley wiley = new Wiley();
    AuthorGroup authorGroup = new AuthorGroup();
    int numAuthor = 0;
    try {
      wiley = Wiley.unmarshal(new StringReader(resultData)); // unmarshal the author group
      authorGroup = wiley.getArticleContent().getAuthorGroup(); //get the author group
      numAuthor = authorGroup.getAuthorCount(); //get the number of author

    }
    catch (Exception ex) {

    }

    String WIDTH = "20";
    String htmlOutput = "";
    htmlOutput +="\n<a name=\""+messageContent.get("articleIdentification")+ "\" id=\""+messageContent.get("articleIdentification")+"\""+"></a>";
    htmlOutput +="<h4>Article ID: "+messageContent.get("articleIdentification")+ "</h4>";
    htmlOutput += "<table  width=\"75%\" border=\"1\" cellpadding=\"0\" cellspacing=\"0\" ><tr bordercolor=\"#9933FF\">\n";
    htmlOutput += "<td width=\"12%\" bgcolor=\"#9999CC\"><strong><font color=\"#0033FF\" size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">Publisher</font></strong></td>\n";
    htmlOutput += "<td width=\"34%\" bgcolor=\"#CCCCFF\"><font color=\"#0033FF\" size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">" +
      messageContent.get("publisherName") + " " +
      messageContent.get("publisherLoc") + "</font></td>\n";
    htmlOutput += "</tr>\n";
    htmlOutput += "<tr bordercolor=\"#9933FF\">\n";
    htmlOutput += "<td width=\"12%\" bgcolor=\"#9999CC\"><strong><font color=\"#0033FF\" size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">Category</font></strong></td>\n";
    htmlOutput += "<td width=\"34%\" bgcolor=\"#CCCCFF\"><font color=\"#0033FF\" size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">" +
        messageContent.get("category") + "</font></td>\n";
    htmlOutput += "</tr>";
    htmlOutput += "<tr bordercolor=\"#9933FF\">\n";
    htmlOutput += "<td width=\"12%\" bgcolor=\"#9999CC\"><strong><font color=\"#0033FF\" size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">Article Title</font></strong></td>\n";
    htmlOutput += "<td width=\"34%\" bgcolor=\"#CCCCFF\"><font color=\"#0033FF\" size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">" +
        messageContent.get("articleTitle") + "</font></td>\n";
    htmlOutput += "</tr>";
    htmlOutput += "<tr bordercolor=\"#9933FF\">";
    htmlOutput += "<td width=\"12%\" bgcolor=\"#9999CC\"><strong><font color=\"#0033FF\" size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">Volume ID</font></strong></td>\n";
    htmlOutput += "<td width=\"34%\" bgcolor=\"#CCCCFF\"><font color=\"#0033FF\" size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">" +
        messageContent.get("VID") + "</font></td>\n";
    htmlOutput += "</tr>";
    htmlOutput += "<tr bordercolor=\"#9933FF\">\n";
    htmlOutput += "<td width=\"12%\" bgcolor=\"#9999CC\"><strong><font color=\"#0033FF\" size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">Issue ID</font></strong></td>\n";
    htmlOutput += "<td width=\"34%\" bgcolor=\"#CCCCFF\"><font color=\"#0033FF\" size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">" +
        messageContent.get("IID") + "</font></td>\n";
    htmlOutput += "</tr>\n";
    htmlOutput += "<tr bordercolor=\"#9933FF\">\n";
    htmlOutput += "<td width=\"12%\" bgcolor=\"#9999CC\"><strong><font color=\"#0033FF\" size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">Date</font></strong></td>\n";
    htmlOutput += "<td width=\"34%\" bgcolor=\"#CCCCFF\"><font color=\"#0033FF\" size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">\n";
    htmlOutput += messageContent.get("month") + " " + messageContent.get("day") +
        " " + messageContent.get("year") + "</font></td>\n";
    htmlOutput += "</tr>\n";
    htmlOutput += "<tr bordercolor=\"#9933FF\">\n";
    htmlOutput += "<td width=\"12%\" bgcolor=\"#9999CC\"><strong><font color=\"#0033FF\" size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">DOI(URI)</font></strong></td>\n";
    htmlOutput += "<td width=\"34%\" bgcolor=\"#CCCCFF\"><font color=\"#0033FF\" size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><i><a target=\"_new_window_1\" href=\"" +
        messageContent.get("href") + "\">" + messageContent.get("href") +
        "</a></i></font></td>\n";
    htmlOutput += "</tr>\n";
    htmlOutput += "<tr bordercolor=\"#9933FF\">\n";
    htmlOutput += "<td width=\"12%\" bgcolor=\"#9999CC\"><strong><font color=\"#0033FF\" size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">Article ID</font></strong></td>\n";
    htmlOutput += "<td width=\"34%\" bgcolor=\"#CCCCFF\"><font color=\"#0033FF\" size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><i><a target=\"_new_window_2\" href=\"" +
        messageContent.get("href") + "\">" +
        messageContent.get("articleIdentification") + "</a></i></font></td>\n";
    htmlOutput += "</tr>\n";
    htmlOutput += "<tr bordercolor=\"#9933FF\">\n";
    htmlOutput += "<td width=\"12%\" bgcolor=\"#9999CC\"><strong><font color=\"#0033FF\" size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">Author Name(s)</font></strong></td>\n";
    htmlOutput += "<td width=\"34%\" bgcolor=\"#CCCCFF\">\n";

    int num = 0; //used for starting from for number
    for (int j = 0; j < numAuthor; j++) {
      num++;
      htmlOutput = htmlOutput + "<font color=\"#0033FF\" size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">" +
          authorGroup.getAuthor(j).getFirstName() + " " +
          authorGroup.getAuthor(j).getLastName() +
          "</font><sup><font size=\"-1\" >" + num +
          "</font></sup>";

    } //end for loop

    htmlOutput += "</td>\n";
    htmlOutput += "</tr>\n";

    htmlOutput += "<tr bordercolor=\"#9933FF\">\n";
    htmlOutput += "<td width=\"12%\" bgcolor=\"#9999CC\"><strong><font color=\"#0033FF\" size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">Author Email(s)</font></strong></td>\n";
    htmlOutput += "<td width=\"34%\" bgcolor=\"#CCCCFF\">\n";
//get author lists
    num = 0; //used for starting from for number
    for (int j = 0; j < numAuthor; j++) {
      num++;
      if (authorGroup.getAuthor(j).getEmailAddress() != null &&
          authorGroup.getAuthor(j).getEmailAddress().length() > 0) {
        htmlOutput += "<font color=\"#0033FF\" size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">\n";
        htmlOutput += "<a href=\"mailto:" +
            authorGroup.getAuthor(j).getEmailAddress() + "\">" +
            authorGroup.getAuthor(j).getEmailAddress() +
            "</a></font><sup><font size=\"-1\" >" + num + "</font></sup>";
      } //end if
    } //end for loop

    htmlOutput += "</td>";
    htmlOutput += "</tr>";

    htmlOutput += "<tr bordercolor=\"#9933FF\">\n";
    htmlOutput += "<td width=\"12%\" bgcolor=\"#9999CC\"><strong><font color=\"#0033FF\" size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">Affiliation(s)</font></strong></td>\n";
    htmlOutput += "<td width=\"34%\" bgcolor=\"#CCCCFF\">\n";
    //get author lists
    Vector affVector = new Vector();
    num = 0; //used for starting from for number
    for (int j = 0; j < numAuthor; j++) {
      commgrids.nuggets.wiley.schema.Affiliation aff = new commgrids.nuggets.
          wiley.schema.Affiliation();
      aff = authorGroup.getAuthor(j).getAffiliation(); //get affiliation
      num++;
      if (!affVector.contains(aff.getContent())) { //check aff
        affVector.add(aff.getContent());

        htmlOutput += "<font color=\"#0033FF\" size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">" +
            aff.getContent() + "</font><sup><font size=\"-1\" > " + num +
            "</font></sup>";
      }
      else {

        htmlOutput += "<sup><font size=\"-1\" > " + num + "</font></sup>\n";

      }

    } //end for loop

    htmlOutput += "</td>\n";
    htmlOutput += "</tr>\n";

    htmlOutput += "<tr bordercolor=\"#9933FF\">\n";
    htmlOutput += "<td width=\"12%\" bgcolor=\"#9999CC\"><strong><font color=\"#0033FF\" size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">Keyword(s)</font></strong></td>\n";
    htmlOutput += "<td width=\"34%\" bgcolor=\"#CCCCFF\"><font color=\"#0033FF\" size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">\n";

    //keyword parts
    int numKey = keywords.getKeywordCount();
    Keywords mesKeyword = new Keywords();
    mesKeyword = (Keywords) messageContent.get("keyword"); //get the keywords from message hash funnction

    for (int k = 0; k < numKey; k++) {

      htmlOutput += mesKeyword.getKeyword(k) + ", ";
    }

    htmlOutput += "</font></td>\n";
    htmlOutput += "</tr>\n";
    htmlOutput += "<tr bordercolor=\"#9933FF\">\n";
    htmlOutput += "<td colspan=\"10\" width=\"12%\" bgcolor=\"#9999CC\"><strong><div align=\"center\"><font color=\"#0033FF\" size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">Abstract</font></div></strong></td>\n";
    htmlOutput += "</tr>";
    htmlOutput += "<tr bordercolor=\"#9933FF\">";
    htmlOutput += "<td colspan=\"10\" width=\"34%\" bgcolor=\"#CCCCFF\"><font color=\"#0033FF\" size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">" +
        messageContent.get("abstract") + "</font></td>\n";
    htmlOutput += "</tr>\n";

    htmlOutput += "<tr bordercolor=\"#9933FF\">";
    htmlOutput += "<td colspan=\"10\" width=\"12%\" bgcolor=\"#9999CC\"><strong><div align=\"center\"><font color=\"#0033FF\" size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">";
    htmlOutput += "<a HREF=\"http://www.cc-pe.net/published/wiley"+messageContent.get("year")+".html#"+messageContent.get("articleIdentification") + "\">CCPE Title/Author Summary</a></font></div></strong></td></tr>\n";

    htmlOutput += "<tr bordercolor=\"#9933FF\">";
    htmlOutput += "<td colspan=\"10\" width=\"12%\" bgcolor=\"#9999CC\"><strong><div align=\"center\"><font color=\"#0033FF\" size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">";
    htmlOutput += "<a HREF=\"http://www.cc-pe.net/published/wiley"+messageContent.get("year")+"abstract.html#"+messageContent.get("articleIdentification") +"\">CCPE Abstracts Summary</a></font></div></strong></td></tr>\n";

    htmlOutput += "</table>\n";
    htmlOutput +="<p>";
   // htmlOutput += "</body>\n";
    //htmlOutput += "</html>";
    return htmlOutput;
  }

}
