package willeyconverter.util;

import org.apache.xerces.parsers.DOMParser;

import org.dom4j.*;
import org.dom4j.Node;
import org.dom4j.XPath;

import org.dom4j.io.*;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.StringReader;
import java.io.*;

import java.util.*;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ByteArrayInputStream;
import java.io.BufferedInputStream;
import java.io.BufferedReader;

import commgrids.nuggets.wiley.*;
import java.io.*;

public class LightWileyHTMLDocument {
  public static String DEFAULT_PROPERTIES = "metadatabrowser.properties";
  private String resultFolderName = "";



  public LightWileyHTMLDocument() {
    try {
      resultFolderName =Util.getProperties().getProperty("wiley.result.folder.name");
      String id = "";
      String rssDocument = "";
      String rssID = "";
      String xmlDocument = "";


    }
    catch (Exception ex) {
     ex.printStackTrace();
    }


  }

  public void generateLightDocument() {

     //FullWileyHTMLDocument ffulldoc = new FullWileyHTMLDocument();
     //String output =ffulldoc.generateWileyOutput("CPE547");

     String outputResult = "";
     boolean append = true;
     PrintStream out = null;
     try {
       out = new PrintStream(new FileOutputStream("light/wiley2006.html"));
     }
     catch (FileNotFoundException ex) {
     }
     System.setOut(out);

     File dirFile = new File(resultFolderName);

     String  fileNames[] =null;


     fileNames= dirFile.list();
     //System.out.println("dirFile.getAbsolutePath():"+ dirFile.getAbsolutePath()  );

     for (int i=0; i<fileNames.length; i++ ) {
       ;
      // System.out.println("fileNames"+i+":"+fileNames[i]);
     }


     for (int i = 0; i < fileNames.length; i++) {

       File file = new File(dirFile.getAbsolutePath()+"/" + fileNames[i]);
       String fContent = "";
       LightWileyHTMLDocument fHTML = new LightWileyHTMLDocument();
       fContent = fHTML.readFile(file);

       String content =generateXML(fContent);
      // String content = fileHTML1.generateXML(uri);

       System.out.println(content);

     }
   }

  public static void main(String[] args) {
    LightWileyHTMLDocument fileHTML1 = new LightWileyHTMLDocument();
    fileHTML1.generateLightDocument();
  }

  public static String readFile(File file) {
    String str = "";
    String output = "";
    BufferedReader in = null;
    InputStream is = null;
    ByteArrayInputStream byaInStream = null;

    try {
      if (file.exists()) {
        in = new BufferedReader(new FileReader(file));
        //is = new BufferedInputStream(new FileInputStream(file));

      }
    }
    catch (IOException ioe) {
      // do nothing
    }
    catch (Exception e) {
      e.printStackTrace();
    }

    if (in != null) {
      try {
        while ( (str = in.readLine()) != null) {
          output += (str + "\n");
        }

        if (in != null) {
          in.close();
        }
      }
      catch (Exception ex) {
        ex.printStackTrace();
      }
    }

    return output;
  }

  public String generateXML(String xmlData) {
    DOMParser parser = new DOMParser();

    FileOutputStream foutStream = null;
    String wileyMessage = "";

    try {
      if (true) {
        SAXReader xmlReader = new SAXReader();
        Document doc = xmlReader.read(new StringReader(xmlData));
        XPath query = doc.createXPath("//wiley");
        List list = query.selectNodes(doc);

        XPath queryAuthor = doc.createXPath(
            "//wiley/articleContent/authorGroup/author");
        List listAuthor = queryAuthor.selectNodes(doc);

        XPath queryTitle = doc.createXPath("//wiley/articleContent");
        List listTitle   = queryTitle.selectNodes(doc);             //also used for abstracts

        XPath queryID = doc.createXPath("//articleInfo");
        List listID = queryID.selectNodes(doc);
       // XPath xpath =null;
        //XPath queryDate =doc.createXPath("//wiley/publicationInfo/coverDate");
        //List listDate =queryDate.selectNodes(doc);
        List listDate =doc.selectNodes("/wiley/publicationInfo/coverDate/@year");

        //System.out.println("year :"+  queryDate.getText());


        Hashtable affiliations = new Hashtable();
        StringBuffer sb = new StringBuffer();
        StringBuffer rss = new StringBuffer();
        StringBuffer authors = new StringBuffer();
        StringBuffer keywords = new StringBuffer();
        String s1 = "  ";
        String s2 = "    ";
        String s3 = "      ";
        String s4 = "        ";
        String s5 = "          ";
        RSSFile rf = new RSSFile();

        String articleID = "";
        String title = "";
        String wileyId = "";

        for (Iterator iter1 = listID.iterator(); iter1.hasNext(); ) {
          Node node1 = (Node) iter1.next();
          articleID = node1.valueOf("articleIdentification");
          //System.out.println("articleID: " + articleID);
        }

        wileyMessage += "<li type=\"circle\"><a name=\"" + articleID +
            "\" id=\"" + articleID + "\"></a><b>" + articleID + ":</b>";

        for (Iterator iter1 = listTitle.iterator(); iter1.hasNext(); ) {
          Node node1 = (Node) iter1.next();
          title = node1.valueOf("articleTitle");
          // System.out.println("title: " + title);
        }
        wileyMessage += "<i>" + title + "</i>\n";

        //get the author list

        wileyMessage += "<ul><li><b>Author(s):</b>";
        Vector authorAffVector = new Vector();
        String wileyName = "";
        String wileyAff = "";
        String wileyEmail = "";

        int numAuthor = listAuthor.size();
        int i = 1;

        //
        for (Iterator iter1 = listAuthor.iterator(); iter1.hasNext(); ) {
          Node nodeAuthor = (Node) iter1.next();
          String fName = nodeAuthor.valueOf("firstName");
          String lName = nodeAuthor.valueOf("lastName");
          String email = nodeAuthor.valueOf("emailAddress");
          String aff = nodeAuthor.valueOf("affiliation");

          if (i < numAuthor) {
            wileyName += fName + " " + lName + ",";
          }
          else {
            wileyName += fName + " " + lName;
          } //end adding first and last name part

          if (!authorAffVector.contains(aff)) {

            authorAffVector.add(aff);
            //System.out.println("aff: " + aff);

            if (i < numAuthor) {
              wileyAff += aff + ",";
            }
            else {
              wileyAff += aff + "</li>";
            }
          } //end adding affiliation part

          i++;
        }
      /*  wileyMessage += wileyName + "</li>\n" + "<li>" + wileyAff + "\n<li>" +
            wileyEmail + "</li>\n";
      */  //modified email is removed
        wileyMessage += wileyName + "</li>\n" + "<li>" + wileyAff +
           "</li>\n";  //modified email is removed

        for (Iterator iter1 = list.iterator(); iter1.hasNext(); ) {
          Node node1 = (Node) iter1.next();
          wileyId = node1.valueOf("nuggetID");
          //  System.out.println("nuggetID: " + wileyId);
        }
         String year="";

         for (Iterator iter1 = listDate.iterator(); iter1.hasNext(); ) {
          Attribute attribute = (Attribute)iter1.next();
          year=  attribute.getValue();

        }



        wileyMessage += "<li type=\"square\"><b></b><a HREF=\"" + wileyId +
            "\">" + wileyId +
            "</a></li>\n";


        wileyMessage += "<li type=\"square\"><a HREF=\"http://www.cc-pe.net/published/wiley"+year+"abstract.html#"+articleID+"\">CCPE Abstracts Summary</a></li>\n";
        wileyMessage += "<li type=\"square\"><a HREF=\"http://www.cc-pe.net/published/wiley"+year+"full.html#"+articleID+"\">CCPE Metadata</a></li></ul</li>\n";

       String articleAbstract="";
        for (Iterator iter1 = listTitle.iterator(); iter1.hasNext(); ) {
         Node node1 = (Node) iter1.next();
         articleAbstract = node1.valueOf("abstract");
         //System.out.println("articleID: " + articleID);
       }

       //wileyMessage += "<li type=\"square\"><b>Abstract:</b>"+ articleAbstract + "</li></ul></li>\n";

        //write result to the file

        //System.out.println("wiley message is: " + wileyMessage);

        /* File file = new File("result.html");
         FileWriter out = new FileWriter(file);
         out.write(wileyMessage.toCharArray());
         */

        /*foutStream = new FileOutputStream(file);
                 foutStream.write(wileyMessage.getBytes());
         */
      }
    }
      catch (Exception e) {
      e.printStackTrace();
    }
    return wileyMessage;
  }

}
