package willeyconverter.util;

import org.apache.xerces.parsers.DOMParser;

import org.dom4j.*;
import org.dom4j.Node;
import org.dom4j.XPath;

import org.dom4j.io.*;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.StringReader;

import java.util.*;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import commgrids.nuggets.wiley.*;
//import commgrids.nuggets.wiley.schema.*;
//import commgrids.nuggets.wiley.rss.schema.*;
/**
 * <p>
 * Title:
 * </p>
 *
 * <p>
 * Description:
 * </p>
 *
 * <p>
 * Copyright: Copyright (c) 2003
 * </p>
 *
 * <p>
 * Company:
 * </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class WilleyReformer {
  String id          = "";
  String rssDocument = "";
  String rssID       = "";
  String xmlDocument = "";
  //java.io.StringWriter swRSS = new java.io.StringWriter();

  /**
   * Creates a new WilleyReformer object.
   */
  public WilleyReformer() {}

  /**
   * Creates a new WilleyReformer object.
   *
   * @param filename DOCUMENT ME!
   */
  public WilleyReformer(String filename) {
    String data = closeTags(readFile(filename));
    generatetXML(data);

    //parse(data, false);
  }



  /**
   * DOCUMENT ME!
   *
   * @param RssDocument_1 - the new value for rssDocument
   */
  public void setRssDocument(String RssDocument_1) {
    rssDocument = RssDocument_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of rssDocument.
   */
  public String getRssDocument() {
    return rssDocument;
  }

  /**
   * DOCUMENT ME!
   *
   * @param RssID_1 - the new value for rssID
   */
  public void setRssID(String RssID_1) {
    rssID = RssID_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of rssID.
   */
  public String getRssID() {
    return rssID;
  }

  /**
   * DOCUMENT ME!
   *
   * @param XmlDocument_1 - the new value for xmlDocument
   */
  public void setXmlDocument(String XmlDocument_1) {
    xmlDocument = XmlDocument_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of xmlDocument.
   */
  public String getXmlDocument() {
    return xmlDocument;
  }

  /**
   * DOCUMENT ME!
   *
   * @param xmlData DOCUMENT ME!
   */
  public void generatetXML(String xmlData) {
    DOMParser parser = new DOMParser();


    try {
      if (true) {
        SAXReader    xmlReader    = new SAXReader();
        Document     doc          = xmlReader.read(new StringReader(xmlData));
        XPath        query        = doc.createXPath("//JWSHDR");
        List         list         = query.selectNodes(doc);
        XPath        query1       = doc.createXPath("//AFF");
        List         list1        = query1.selectNodes(doc);
        Hashtable    affiliations = new Hashtable();
        StringBuffer sb           = new StringBuffer();
        StringBuffer rss          = new StringBuffer();
        StringBuffer authors      = new StringBuffer();
        StringBuffer keywords     = new StringBuffer();
        String       s1           = "  ";
        String       s2           = "    ";
        String       s3           = "      ";
        String       s4           = "        ";
        String       s5           = "          ";
        RSSFile      rf           = new RSSFile();

        for (Iterator iter1 = list1.iterator(); iter1.hasNext();) {
          Node        node1 = (Node) iter1.next();
          Affiliation aff = new Affiliation();

          aff.type = node1.valueOf("@TYPE").trim();
          aff.cny  = node1.valueOf("@CNY").trim();
          aff.data = node1.getStringValue().trim();
          affiliations.put(node1.valueOf("@OID"),
                           aff);

          // System.out.println(node1.valueOf("@OID") + ", " + aff);
        }

        query1 = doc.createXPath("//AU");
        list1  = query1.selectNodes(doc);

        for (Iterator iter1 = list1.iterator(); iter1.hasNext();) {
          Node node1 = (Node) iter1.next();

          rf.author.append(node1.valueOf("FNMS").trim());
          rf.author.append(" ");
          rf.author.append(node1.valueOf("SNM").trim());

          if (iter1.hasNext()) {
            rf.author.append(", ");
          }

          //author section
          authors.append(s3);
          authors.append("<author>");
          authors.append("\n");

          //firstName
          authors.append(s4);
          authors.append("<firstName>").append(node1.valueOf("FNMS").trim())
                 .append("</firstName>");
          authors.append("\n");

          //lastName
          authors.append(s4);
          authors.append("<lastName>").append(node1.valueOf("SNM").trim())
                 .append("</lastName>");
          authors.append("\n");

          //emailAddress
          authors.append(s4);
          authors.append("<emailAddress>").append(node1.valueOf("EAD").trim())
                 .append("</emailAddress>");
          authors.append("\n");

          //affiliation
          Affiliation aff = (Affiliation) affiliations.get(node1.valueOf("@ORF"));
          authors.append(s4);
          authors.append("<affiliation type='").append(aff.type)
                 .append("' cny='").append(aff.cny).append("'>").append(aff.data)
                 .append("</affiliation>");
          authors.append("\n");

          //author section end
          authors.append(s3);
          authors.append("</author>");
          authors.append("\n");

          /*System.out.println(node1.valueOf("FNMS").trim());
             System.out.println(node1.valueOf("SNM").trim().length());
             System.out.println(node1.valueOf("EAD").trim().length());
             System.out.println(((Affiliation) affiliations.get(node1.valueOf("@ORF"))).data);*/
        }

        query1 = doc.createXPath("//KWDG/KWD");
        list1  = query1.selectNodes(doc);

        for (Iterator iter1 = list1.iterator(); iter1.hasNext();) {
          Node node1 = (Node) iter1.next();

          //keyword
          keywords.append(s4);
          keywords.append("<keyword>").append(node1.getStringValue().trim())
                  .append("</keyword>");
          keywords.append("\n");
        }

        Iterator iter = list.iterator();

        Node     node = (Node) iter.next();
        sb.append("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
        sb.append("<wiley>");
        sb.append("\n");

        //publisherInfo section
        sb.append(s1);
        sb.append("<publisherInfo>");
        sb.append("\n");

        //publisherName
        sb.append(s2);
        sb.append("<publisherName>").append(filter(node.valueOf("//PNM").trim()))
          .append("</publisherName>");
        sb.append("\n");

        //publisherLoc
        sb.append(s2);
        sb.append("<publisherLoc>").append(filter(node.valueOf("//PLOC").trim()))
          .append("</publisherLoc>");
        sb.append("\n");

        //publisherInfo section end
        sb.append(s1);
        sb.append("</publisherInfo>");
        sb.append("\n");

        //JournalInfo section
        sb.append(s1);
        sb.append("<JournalInfo>");
        sb.append("\n");

        //JID
        sb.append(s2);
        sb.append("<JID>").append(node.valueOf("//JID").trim()).append("</JID>");
        sb.append("\n");

        //JTitle
        sb.append(s2);
        sb.append("<JTitle language='")
          .append(node.valueOf("//JTL/@LANGUAGE").trim()).append("'>")
          .append(node.valueOf("//JTL").trim()).append("</JTitle>");
        sb.append("\n");

        //JTLSortGroup section
        sb.append(s2);
        sb.append("<JTLSortGroup>");
        sb.append("\n");

        //JTLsort
        sb.append(s3);
        sb.append("<JTLSort>").append(node.valueOf("//JTLSORT").trim()).append("</JTLSort>");
        sb.append("\n");

        //JTLDisplay
        sb.append(s3);
        sb.append("<JTLDisplay>").append(node.valueOf("//JTLDISPLAY").trim())
          .append("</JTLDisplay>");
        sb.append("\n");

        //JTLSortGroup
        sb.append(s2);
        sb.append("</JTLSortGroup>");
        sb.append("\n");

        //ISSN
        sb.append(s2);
        sb.append("<ISSN type='").append(node.valueOf("//ISSN/@TYPE").trim())
          .append("'>").append(node.valueOf("//ISSN").trim()).append("</ISSN>");
        sb.append("\n");

        //subject
        sb.append(s2);
        sb.append("<subject>").append(node.valueOf("//SUBJ").trim()).append("</subject>");
        sb.append("\n");

        //JournalInfo section end
        sb.append(s1);
        sb.append("</JournalInfo>");
        sb.append("\n");

        //publicationInfo section
        sb.append(s1);
        sb.append("<publicationInfo>");
        sb.append("\n");

        //VID
        sb.append(s2);
        sb.append("<VID>").append(node.valueOf("//VID").trim()).append("</VID>");
        sb.append("\n");

        //IID
        sb.append(s2);
        sb.append("<IID>").append(node.valueOf("//IID").trim()).append("</IID>");
        sb.append("\n");

        //coverDate
        sb.append(s2);
        sb.append("<coverDate year='").append(node.valueOf("//CD/@YEAR").trim())
          .append("' month='").append(node.valueOf("//CD/@MONTH").trim())
          .append("' day='").append(node.valueOf("//CD/@DAY").trim())
          .append("' endyear='").append(node.valueOf("//CD/@ENDYR").trim())
          .append("' endmonth='").append(node.valueOf("//CD/@ENDMON").trim())
          .append("' endday='").append(node.valueOf("//CD/@ENDDAY").trim())
          .append("'>").append(node.valueOf("//CD").trim()).append("</coverDate>");
        sb.append("\n");
        rf.date.append(node.valueOf("//CD/@MONTH").trim());
        rf.date.append(" ");
        rf.date.append(node.valueOf("//CD/@DAY").trim());
        rf.date.append(" ");
        rf.date.append(node.valueOf("//CD/@YEAR").trim());

        //publicationInfo section end
        sb.append(s1);
        sb.append("</publicationInfo>");
        sb.append("\n");

        //articleContent section
        sb.append(s1);
        sb.append("<articleContent>");
        sb.append("\n");

        //articleInfo section
        sb.append(s2);
        sb.append("<articleInfo>");
        sb.append("\n");

        //articleIdentification
        sb.append(s3);
        sb.append("<articleIdentification>")
          .append(node.valueOf("//AID ").trim()).append("</articleIdentification>");
        sb.append("\n");

        //digitalObjectIdentifier
        id    = node.valueOf("//ARTINFO//DOI/@HREF").trim();
        id = id.substring(id.lastIndexOf("/")+1);
        rssID = getID();
        rf.articleId.append(rssID);
        id = "http://dx.doi.org/" + node.valueOf("//ARTINFO//DOI/@HREF").trim();
        rf.link.append(id);

        sb.append(s3);
        sb.append("<digitalObjectIdentifier href='").append(id)
          .append("' origin='")
          .append(node.valueOf("//ARTINFO//DOI/@ORIGIN").trim().toLowerCase())
          .append("' registered='")
          .append(node.valueOf("//ARTINFO//DOI/@REGISTERED").trim().toLowerCase())
          .append("' level='")
          .append(node.valueOf("//ARTINFO//DOI/@LEVEL").trim().toLowerCase())
          .append("'>").append(node.valueOf("//ARTINFO//DOI").trim()).append("</digitalObjectIdentifier>");
        sb.append("\n");

        //articleType
        sb.append(s3);
        sb.append("<articleType articleTy='")
          .append(node.valueOf("//ARTTY/@ARTTY").trim()).append("'>")
          .append(node.valueOf("//ARTTY").trim()).append("</articleType>");
        sb.append("\n");

        //category
        sb.append(s3);
        sb.append("<category>").append(node.valueOf("//CATEG").trim()).append("</category>");
        sb.append("\n");
        rf.category.append(node.valueOf("//CATEG ").trim());

        //articleInfo section end
        sb.append(s2);
        sb.append("</articleInfo>");
        sb.append("\n");

        //articleTitle
        sb.append(s2);
        sb.append("<articleTitle>").append(node.valueOf("//ATL").trim()).append("</articleTitle>");
        sb.append("\n");
        rf.articleTitle.append(node.valueOf("//ATL").trim());

        //authorGroup section
        sb.append(s2);
        sb.append("<authorGroup>");
        sb.append("\n");

        //author section
        sb.append(authors);

        //authorGroup section end
        sb.append(s2);
        sb.append("</authorGroup>");
        sb.append("\n");

        //abstract
        sb.append(s2);
        sb.append("<abstract language='")
          .append(node.valueOf("//ABS/@LANGUAGE").trim()).append("'>")
          .append(filter(node.valueOf("//ABS"))).append("</abstract>");
        sb.append("\n");

        //keywords section
        sb.append(s2);
        sb.append("<keywords>");
        sb.append("\n");

        //keyword section
        sb.append(keywords);

        //keywords section end
        sb.append(s2);
        sb.append("</keywords>");
        sb.append("\n");

        //articleContent section end
        sb.append(s1);
        sb.append("</articleContent>");
        sb.append("\n");

        //nuggetID
        sb.append(s1);
        sb.append("<nuggetID>").append(id).append("</nuggetID>");
        sb.append("\n");

        sb.append("</wiley>");

        xmlDocument = sb.toString();

        /*

        ////////////////////////////////////rss section///////////////////////////////////////////////////
        Item item =new Item();                                            //new RSS Item
        item.setArticleTitle(rf.articleTitle.toString());                //set the article title
        item.setCategory(rf.category.toString());                        //set the category
        item.setLink(rf.link.toString());                              //set the article URI
        item.setArticleId(rf.articleId.toString());          //set the article identification
        item.setAuthor(rf.author.toString() ); //set the author
        item.setDate(rf.date.toString()); //set the date
        ///////////////////////////////////end rss section////////////////////////////////////////////////


                 //new string write object for rss
        item.marshal(swRSS);
        */

        rss.append("<Item>");
        rss.append("\n");
        rss.append(s1);
        rss.append("<author>").append(rf.author).append("</author>");
        rss.append("\n");
        rss.append(s1);
        rss.append("<date>").append(rf.date).append("</date>");
        rss.append("\n");
        rss.append(s1);
        rss.append("<category>").append(rf.category).append("</category>");
        rss.append("\n");
        rss.append(s1);
        rss.append("<articleId>").append(rf.articleId).append("</articleId>");
        rss.append("\n");
        rss.append(s1);
        rss.append("<articleTitle>").append(rf.articleTitle).append("</articleTitle>");
        rss.append("\n");
        rss.append(s1);
        rss.append("<link>").append(rf.link).append("</link>");
        rss.append("\n");
        rss.append("</Item>");

         rssDocument = rss.toString();
        //rssDocument =swRSS.toString();

        //System.out.println(sb.toString());
        //System.out.println(node.asXML());
        //System.out.println(databaseResult);
      }
    } catch (Exception e) {
      e.printStackTrace();
    }
  }

    public void insertData(String topic, String uri, String file){
    Database db =new Database();
    WilleyReformer wr =new WilleyReformer(file);
    db.insertXMLContent(topic, uri, wr.getRssDocument(), wr.getXmlDocument());
  }


  /**
   * DOCUMENT ME!
   *
   * @param args DOCUMENT ME!
   */
  public static void main(String[] args) {
    System.out.println("argument :" +args[0]);
    WilleyReformer wr =new WilleyReformer(args[0]);

    //WilleyReformer wr = new WilleyReformer("C:/colima" + "/my-java-projects" + "/WilleyConverter" + "/files" + "/616_hdp.sgm");
    System.out.println("rss document is:" +wr.getRssDocument());
    System.out.println();
    System.out.println(wr.getRssID());
    System.out.println();
    System.out.println("xml document is:" +wr.getXmlDocument());

    Database db =new Database();
    //db.insertXMLContent("2004(16)/13","CPE761",wr.getRssDocument(), wr.getXmlDocument());
  }

  /**
   * DOCUMENT ME!
   *
   * @param file DOCUMENT ME!
   *
   * @return DOCUMENT ME!
   */
  public static String readFile(File file) {
    String         str    = "";
    String         output = "";
    BufferedReader in     = null;
    InputStream    is     = null;

    try {
      if (file.exists()) {
        in = new BufferedReader(new FileReader(file));
      }
    } catch (IOException ioe) {
      // do nothing
    } catch (Exception e) {
      e.printStackTrace();
    }

    if (in != null) {
      try {
        while ((str = in.readLine()) != null) {
          output += (str + "\n");
        }

        if (in != null) {
          in.close();
        }
      } catch (Exception ex) {
        ex.printStackTrace();
      }
    }

    return output;
  }

  /**
   * DOCUMENT ME!
   *
   * @param filename DOCUMENT ME!
   *
   * @return DOCUMENT ME!
   */
  public static String readFile(String filename) {
    File           file   = new File(filename);
    String         str    = "";
    String         output = "";
    BufferedReader in     = null;
    InputStream    is     = null;

    try {
      if (file.exists()) {
        in = new BufferedReader(new FileReader(file));
      }
    } catch (IOException ioe) {
      // do nothing
    } catch (Exception e) {
      e.printStackTrace();
    }

    if (in != null) {
      try {
        while ((str = in.readLine()) != null) {
          output += (str + "\n");
        }

        if (in != null) {
          in.close();
        }
      } catch (Exception ex) {
        ex.printStackTrace();
      }
    }

    return output;
  }

  /**
   * DOCUMENT ME!
   *
   * @return DOCUMENT ME!
   */
  private String getID() {
    int dot = id.indexOf('.');
    return id.substring(0, dot).toUpperCase() +
           id.substring(dot + 1).toUpperCase();
  }

  /**
   * DOCUMENT ME!
   *
   * @param data DOCUMENT ME!
   *
   * @return DOCUMENT ME!
   */
  private String closeTags(String data) {
    StringBuffer sb          = new StringBuffer();
    String       tag         = "";
    String       tempData    = "";
    int          start       = 0;
    int          end         = -1;
    int          endClosed   = -1;
    int          startClosed = -1;
    int          space       = 0;
    int          tagClosed   = -1;
    int          dataLength  = data.length();

    data = data.substring(data.indexOf("<JWSART"));

    for (int i = 0; i < dataLength; i = start) {
      tag         = "";
      start       = data.indexOf("<", i);
      startClosed = data.indexOf("</", i);
      end         = data.indexOf(">", start);
      endClosed   = data.indexOf("/>", start);
      space       = data.indexOf(" ", start);

      /*System.out.println("i " + i + " start " + start + " startClosed " +
         startClosed + " end " + end + " endClosed " +
         endClosed + " space " + space + " TAG= " + tag);
       */
      if (start < 0) {
        break;
      }

      if (endClosed > 0) {
        //System.out.println("inside endClosed TAG= " + tag);
        sb.append(data.substring(start, endClosed + 1)).append("\n");
        start = endClosed;
      } else if ((startClosed > 0) && (startClosed == start)) {
        tag = data.substring(startClosed, end + 1);
        sb.append(data.substring(startClosed, end + 1)).append("\n");

        //System.out.println("inside startClosed TAG= " + tag);
        start = end;
      } else if ((space > 0) && (space < end)) {
        tag       = data.substring(start + 1, space);
        tagClosed = data.indexOf("</" + tag + ">", space);

        if (tagClosed > 0) {
          sb.append(data.substring(start, end + 1));
          tempData = data.substring(end + 1, tagClosed);
          tempData = tempData.replaceAll("&lpar;", "(").replaceAll("&rpar;", ")")
                             .replaceAll("&commat;", "@")
                             .replaceAll("&hyphen;", "-")
                             .replaceAll("&dash;", "-")
                             .replaceAll("&mdash;", "-")
                             .replaceAll("&ndash;", "-")
                             .replaceAll("&szlig;", "")
                             .replaceAll("&mu;", "&amp;mu;")
                             .replaceAll("&uuml;", "")
                             .replaceAll("&sol;", "&amp;sol;")
                             .replaceAll("&ouml;", "&amp;ouml;")
                             .replaceAll("&lsquo;", "&amp;lsquo;")
                             .replaceAll("&rsquo;", "&amp;rsquo;")
                             .replaceAll("&ndash;", "-")
                             .replaceAll("&percnt;", "&amp;percnt;")
                             .replaceAll("&acirc;", "&amp;acirc;")
                             .replaceAll("&eacute;", "&amp;eacute;")
                             .replaceAll("&ccedil;", "&amp;ccedil;")
                             .replaceAll("&atilde;", "&amp;atilde;")
                             .replaceAll("&oacute;", "&amp;oacute;")
                             .replaceAll("&auml;", "&amp;auml;")
                             .replaceAll("&", "&#38;")
                             .replaceAll("&sol;", "/").replaceAll("&copy;",
                                                                  "&amp;copy;");

          //tempData = tempData.replaceAll("&", "&amp;");
          if (tempData.indexOf("<") < 0) {
            sb.append(tempData);
          }

          sb.append("\n");

          //System.out.println("inside space tag closed TAG= " + tag);
        } else {
          sb.append(data.substring(start, end + 1).replaceAll(">", "/>"))
            .append("\n");

          //System.out.println("inside space tag NOT closed TAG= " + tag);
        }

        start = end;
      } else if ((end > 0) && (end < space)) {
        tag       = data.substring(start + 1, end);
        tagClosed = data.indexOf("</" + tag + ">", end);

        if (tagClosed > 0) {
          sb.append(data.substring(start, end + 1));
          tempData = data.substring(end + 1, tagClosed);
          tempData = tempData.replaceAll("&lpar;", "(").replaceAll("&rpar;", ")")
                             .replaceAll("&commat;", "@")
                             .replaceAll("&hyphen;", "-")
                             .replaceAll("&dash;", "-")
                             .replaceAll("&mdash;", "-")
                             .replaceAll("&szlig;", "")
                             .replaceAll("&mu;", "&amp;mu;")
                             .replaceAll("&uuml;", "")
                             .replaceAll("&ouml;", "&amp;ouml;")
                             .replaceAll("&lsquo;", "&amp;lsquo;")
                             .replaceAll("&rsquo;", "&amp;rsquo;")
                             .replaceAll("&ndash;", "-")
                             .replaceAll("&sol;", "&amp;sol;")
                             .replaceAll("&percnt;", "&amp;percnt;")
                             .replaceAll("&acirc;", "&amp;acirc;")
                             .replaceAll("&eacute;", "&amp;eacute;")
                             .replaceAll("&ccedil;", "&amp;ccedil;")
                             .replaceAll("&atilde;", "&amp;atilde;")
                             .replaceAll("&oacute;", "&amp;oacute;")
                             .replaceAll("&auml;", "&amp;auml;")
                             .replaceAll("&", "&amp;")
                             .replaceAll("&sol;", "/").replaceAll("&copy;",
                                                                  "&amp;copy;");

          //System.out.println("TempData "+tempData);
          if (tempData.indexOf("<") < 0) {
            sb.append(tempData);
          }

          sb.append("\n");

          //System.out.println("inside end tag closed TAG= " + tag);
        } else {
          sb.append(data.substring(start, end + 1).replaceAll(">", "/>"))
            .append("\n");

          //System.out.println("inside end tag NOT closed TAG= " + tag);
        }

        start = end;
      }

      //System.out.println(" i = " + i + " : start = " + start);
    }

    return sb.toString();
  }

  /**
   * DOCUMENT ME!
   *
   * @param str DOCUMENT ME!
   *
   * @return DOCUMENT ME!
   */
  private String filter(String str) {
    String tempData = str.replaceAll("&lpar;", "(").replaceAll("&rpar;", ")")
                         .replaceAll("&commat;", "@").replaceAll("&hyphen;", "-")
                         .replaceAll("&sol;", "/");
    tempData = tempData.replaceAll("&", "&amp;");

    //System.out.println("TempData: "+tempData);
    return tempData;
  }
}
